# I3dShTreeElement.h File Reference

## Classes
struct | I3DShTreeElement
struct | RelinkTreeElementInfo
struct | I3DShTreeElementMember
## Defines
#define | kApplyConstraint true
#define | kIgnoreConstraint false
#define | kBMUpdatePhysics 1
#define | kPathNameSeparator '.'
#define | kOpAllowed 0x00
#define | kOpAlwaysForbidden 0x01
#define | kOpShouldDettachFirst 0x02
#define | kOpForbiddenUnkown 0x04
## Enumerations
enum | ETreeTransformMode { kXTreeBehaviorDefault = 0, kXTreeBehaviorTrackT = 1, kXTreeBehaviorTrackR = 2, kInvalidTransformMode = 0xFFFFFFFF }
enum | ETreeOperation { kNoOperation = 0, kCopyTreeOperation, kDuplicateTreeOperation, kDeleteTreeOperation, kChangeTransformOperation, kChangeParentTreeOperation, kAddChildTreeOperation, kPromoteToMasterOperation, kCutTreeOperation, kInvalidOperation = 0xFFFFFFFF }
enum | ETreeType { kGroup = 1, kInstance = 2, kHelperObject = 3, kJoint = 4, kInvisibleTree = 5, kWorkingBox = 16 }
## Functions
| MCDEFINE_GUID_SAFELIB (IID_I3DShTreeElement, 0xD68FEB00L, 0x3A02, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02)
| MCDEFINE_GUID_SAFELIB (IID_I3DShExtension, 0xE9F9B4A1L, 0x3A02, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02)
| MCDEFINE_GUID_SAFELIB (IID_I3DShTreeElementMember, 0xE37B67B3, 0x1768, 0x11d3, 0xba, 0xb4, 0x0, 0x0, 0xe8, 0xdd, 0x86, 0xd4)
| MCDEFINE_GUID_SAFELIB (CLSID_StandardSceneInstance, 0x7aaf6f4c, 0xde5a, 0x11d2, 0x8e, 0xe7, 0x0, 0x60, 0x97, 0xb, 0xc5, 0x21)
| MCDEFINE_GUID_SAFELIB (CLSID_StandardHelperObject, 0xb3872731, 0xdbfd, 0x11d2, 0x88, 0x85, 0x0, 0x60, 0x97, 0x14, 0x85, 0x21)
| MCDEFINE_GUID_SAFELIB (CLSID_StandardHelperJointObject, 0xdcab71ad, 0xfd41, 0x499a, 0x8a, 0xe1, 0xf0, 0x3a, 0xf2, 0x4, 0xcc, 0xe0)

## Define Documentation

#define kApplyConstraint true

#define kBMUpdatePhysics 1

#define kIgnoreConstraint false

#define kOpAllowed 0x00

#define kOpAlwaysForbidden 0x01

#define kOpForbiddenUnkown 0x04

#define kOpShouldDettachFirst 0x02

#define kPathNameSeparator '.'

## Enumeration Type Documentation

enum ETreeOperation

Enumerator:

  kNoOperation |
  kCopyTreeOperation |
  kDuplicateTreeOperation |
  kDeleteTreeOperation |
  kChangeTransformOperation |
  kChangeParentTreeOperation |
  kAddChildTreeOperation |
  kPromoteToMasterOperation |
  kCutTreeOperation |
  kInvalidOperation |

enum ETreeTransformMode

Enumerator:

  kXTreeBehaviorDefault |
  kXTreeBehaviorTrackT |
  kXTreeBehaviorTrackR |
  kInvalidTransformMode |

enum ETreeType

Enumerator:

  kGroup |
  kInstance |
  kHelperObject |
  kJoint |
  kInvisibleTree |
  kWorkingBox |

## Function Documentation

MCDEFINE_GUID_SAFELIB | ( | CLSID_StandardHelperJointObject | ,
|  | 0xdcab71ad | ,
|  | 0xfd41 | ,
|  | 0x499a | ,
|  | 0x8a | ,
|  | 0xe1 | ,
|  | 0xf0 | ,
|  | 0x3a | ,
|  | 0xf2 | ,
|  | 0x4 | ,
|  | 0xcc | ,
|  | 0xe0 |  |
| ) |  |  |

MCDEFINE_GUID_SAFELIB | ( | CLSID_StandardHelperObject | ,
|  | 0xb3872731 | ,
|  | 0xdbfd | ,
|  | 0x11d2 | ,
|  | 0x88 | ,
|  | 0x85 | ,
|  | 0x0 | ,
|  | 0x60 | ,
|  | 0x97 | ,
|  | 0x14 | ,
|  | 0x85 | ,
|  | 0x21 |  |
| ) |  |  |

MCDEFINE_GUID_SAFELIB | ( | CLSID_StandardSceneInstance | ,
|  | 0x7aaf6f4c | ,
|  | 0xde5a | ,
|  | 0x11d2 | ,
|  | 0x8e | ,
|  | 0xe7 | ,
|  | 0x0 | ,
|  | 0x60 | ,
|  | 0x97 | ,
|  | 0xb | ,
|  | 0xc5 | ,
|  | 0x21 |  |
| ) |  |  |

MCDEFINE_GUID_SAFELIB | ( | IID_I3DShTreeElementMember | ,
|  | 0xE37B67B3 | ,
|  | 0x1768 | ,
|  | 0x11d3 | ,
|  | 0xba | ,
|  | 0xb4 | ,
|  | 0x0 | ,
|  | 0x0 | ,
|  | 0xe8 | ,
|  | 0xdd | ,
|  | 0x86 | ,
|  | 0xd4 |  |
| ) |  |  |

MCDEFINE_GUID_SAFELIB | ( | IID_I3DShExtension | ,
|  | 0xE9F9B4A1L | ,
|  | 0x3A02 | ,
|  | 0x101C | ,
|  | 0x88 | ,
|  | 0x5F | ,
|  | 0x04 | ,
|  | 0x02 | ,
|  | 0x1C | ,
|  | 0x00 | ,
|  | 0x70 | ,
|  | 0x02 |  |
| ) |  |  |

MCDEFINE_GUID_SAFELIB | ( | IID_I3DShTreeElement | ,
|  | 0xD68FEB00L | ,
|  | 0x3A02 | ,
|  | 0x101C | ,
|  | 0x88 | ,
|  | 0x5F | ,
|  | 0x04 | ,
|  | 0x02 | ,
|  | 0x1C | ,
|  | 0x00 | ,
|  | 0x70 | ,
|  | 0x02 |  |
| ) |  |  |